/* @clake/react-bootstrap4-window v0.1.6 | by Clake
 * Copyright (c) 2019 Clake,
 * 2019-01-09T14:29:10+0800
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

require('./css/CTableInput.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CTableInput = function (_React$Component) {
    _inherits(CTableInput, _React$Component);

    function CTableInput(props) {
        _classCallCheck(this, CTableInput);

        var _this = _possibleConstructorReturn(this, (CTableInput.__proto__ || Object.getPrototypeOf(CTableInput)).call(this, props));

        _this.changeHandler = function (e) {
            _this.setState({
                value: e.target.value
            });
            if (typeof _this.props.onChange === 'function') {
                _this.props.onChange(e, e.target.value);
            }
        };

        _this.state = {
            value: _this.props.data || '',
            comboData: _this.props.comboData
        };
        return _this;
    }

    _createClass(CTableInput, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.setState({
                value: nextProps.data || '',
                comboData: nextProps.comboData
            });
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            if (nextProps.comboData !== this.props.comboData) {
                return true;
            }
            if (nextProps.disabled !== this.props.disabled) {
                return true;
            }
            return nextState.value !== this.state.value;
        }
    }, {
        key: 'getClasses',
        value: function getClasses() {
            var base = 'ck-ctable-input';

            return (0, _bind2.default)(base, this.props.className);
        }
    }, {
        key: 'render',
        value: function render() {
            var inputStyle = {};
            if (this.props.align) {
                inputStyle.textAlign = this.props.align;
            }
            return _react2.default.createElement(
                'div',
                { className: this.getClasses() },
                _react2.default.createElement('input', _extends({ type: 'text' }, this.props, { onChange: this.changeHandler, disabled: this.props.disabled, style: inputStyle, value: this.state.value }))
            );
        }
    }, {
        key: 'renderCombo',
        value: function renderCombo() {}
    }, {
        key: 'renderCalendar',
        value: function renderCalendar() {}
    }]);

    return CTableInput;
}(_react2.default.Component);

CTableInput.propTypes = {
    data: _propTypes2.default.any,
    align: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    combo: _propTypes2.default.object,
    comboData: _propTypes2.default.any,
    calendar: _propTypes2.default.object,
    onChange: _propTypes2.default.func
};

CTableInput.defaultProps = {};

exports.default = CTableInput;
//# sourceMappingURL=CTableInput.js.map
